<template>
  <div>
    <div v-bind:id="name" v-bind:style="{ fontSize: fontSize + 'px' }" />
  </div>
</template>

<script>
var d3 = require("d3");

export default {
  name: "commitsGraph",
  props: {
    data: Array,
    name: String
  },
  data: function() {
    return {
      margin: { top: 20, right: 50, bottom: 60, left: 80 },
      width: 500,
      height: 400,
      legendCellSize: 30,
      tooltipWidth: 210,
      fontSize: 10,
      dateOption: { year: "numeric", month: "long", day: "numeric" }
    };
  },
  mounted() {
    this.width = this.width - this.margin.right - this.margin.left;
    this.height = this.width - this.margin.top - this.margin.bottom;
    let viewableData = [];
    let dates = [];
    let authors = [];
    viewableData["columns"] = ["date"];
    for (let commit of this.data) {
      let date = this.parseJavaDateToString(commit.date);
      if (dates.indexOf(date) <= -1) {
        dates.push(date);
      }
      if (authors.indexOf(this.parseAuthor(commit.author)) <= -1) {
        authors.push(this.parseAuthor(commit.author));
      }
    }
    dates.reverse();
    authors.sort();
    for (let y = 0; y < authors.length; y++) {
      viewableData["columns"].push(authors[y]);
    }
    for (let i = 0; i < dates.length; i++) {
      viewableData.push({ date: dates[i] });
      for (let y = 0; y < authors.length; y++) {
        viewableData[i][authors[y]] = 0;
      }
    }
    for (let commit of this.data) {
      let date = this.parseJavaDateToString(commit.date);
      let dateIndice = dates.indexOf(date);
      viewableData[dateIndice][this.parseAuthor(commit.author)] += 1;
    }
    const svg = d3
      .select(`#${this.name}`)
      .append("svg")
      .attr("id", "svg")
      .attr("width", this.width + this.margin.left + this.margin.right)
      .attr("height", this.height + this.margin.top + this.margin.bottom)
      .attr(
        "transform",
        "translate(" + this.margin.left + "," + this.margin.top + ")"
      );
    // Transpose the data into layers
    var stack = d3
      .stack()
      .keys(authors)
      .order(d3.stackOrderNone)
      .offset(d3.stackOffsetNone);

    var series = stack(viewableData);

    const x = d3
      .scaleBand()
      .domain(viewableData.map(d => d.date))
      .range([0, this.width])
      .padding(0.1);
    // A la verticale, notre range est la hauteur du graphique et notre domaine va de 0 à la valeur maximale des séries
    // Voir un peu plus bas l'objet series
    const y = d3
      .scaleLinear()
      .domain([0, d3.max(series[series.length - 1], d => d[1])])
      .range([this.height, 0]);

    let crayons = d3.scaleSequential(
      [0, authors.length],
      d3.interpolateRainbow
    );
    let colors = [];
    for (let i = 0; i < authors.length; i++) {
      colors.push(crayons(i));
    }

    // Pour chaque série (chaque catégorie) nous créons un groupe
    // Nous pouvons alors associer la couleur correspondant à cette série en fonction de son indice
    let groups = svg
      .selectAll("g")
      .data(series)
      .enter()
      .append("g")
      .style("fill", (d, i) => colors[i]);

    let XaxisMap = viewableData.map(d => {
      let option = { year: "numeric", month: "long" };
      let date = new Date(d.date.replace(/é/g, "e"));
      return date.toLocaleDateString("fr", option);
    });
    XaxisMap = XaxisMap.filter(function(elem, index, self) {
      return index === self.indexOf(elem);
    });

    const XaxisScale = d3
      .scaleBand()
      .domain(XaxisMap)
      .range([0, this.width])
      .padding(0.1);

    // Sur l'axe horizontal, on filtre les dates afficher
    const xAxis = d3.axisBottom(XaxisScale).tickValues(XaxisScale.domain());
    svg
      .append("g")
      .attr("class", "x axis")
      .attr("transform", "translate(-20," + this.height + ")")
      .call(xAxis)
      .selectAll("text")
      .attr("transform", "rotate(-45)")
      .attr("dx", "-4em")
      .style("fill", "white")
      .style("-size", "1.2em")
      .style("text-anchor", "middle");

    svg
      .append("g")
      .attr("class", "y axis")
      .call(y)
      .append("text")
      .attr("fill", "#000")
      .attr("transform", "rotate(-90)")
      .attr("y", 0)
      .attr("dy", "0.71em")
      .style("text-anchor", "end")
      .text("nombre de commit");

    // Pour chaque élément d'une série nous construisons un rectangle dont la position sur l'axe X est liée à sa date,
    // Sa largeur est dépendante du nombre de données et fournie par x.bandWidth()
    // Sur l'axe Y, la hauteur du rectangle est donnée par d[0] et d[1] correspondant au début et à la fin du rectangle.
    // eslint-disable-next-line no-unused-vars
    let rect = groups
      .selectAll("rect")
      .data(d => d)
      .enter()
      .append("rect")
      .attr("x", d => x(d.data.date))
      .attr("width", x.bandwidth())
      .attr("y", d => y(d[1]))
      .attr("height", d => this.height - y(d[1] - d[0]));
    this.addLegend(colors, svg, authors);

    //this.addMovingAverage(svg, viewableData, x, y);
    //let tooltip = this.addTooltip(authors.length);
    //this.handleMouseEvent(viewableData, x, y, tooltip);
  },
  methods: {
    movingAverage(array, count) {
      var result = [],
        val;

      for (
        var i = Math.floor(count / 2), len = array.length - count / 2;
        i < len;
        i++
      ) {
        val = d3.mean(array.slice(i - count / 2, i + count / 2), d => d.Total);
        result.push({ date: array[i].date, value: val });
      }

      return result;
    },
    addMovingAverage(svg, data, x, y) {
      const line = d3
        .line()
        .x(d => x.bandwidth() / 2 + x(d.date)) // décalage pour centrer au milieu des barres
        .y(d => y(d.value))
        .curve(d3.curveMonotoneX); // Fonction de courbe permettant de l'adoucir

      let mm10array = this.movingAverage(data, 10); // Moyenne mobile sur 10 jours

      svg
        .append("path")
        .datum(mm10array)
        .attr("d", line)
        .style("fill", "none")
        .style("stroke", "#ffab00")
        .style("stroke-width", 3);

      let lastEntry = mm10array[mm10array.length - 1];
      svg
        .append("text")
        .attr(
          "transform",
          "translate(" + x(lastEntry.date) + "," + y(lastEntry.value) + ")"
        ) // Le dernier point de la courbe
        .attr("dx", "0.5em") // Auquel on ajoute un léger décalage sur X
        .attr("dy", "0.5em") // et sur Y
        .style("fill", "#ffab00")
        .style("font-size", "0.8em")
        .style("font-weight", "500")
        .text("MM10");
    },
    parseJavaDateToString(javaDate) {
      let date = new Date(javaDate);
      return date.toLocaleDateString("fr", this.dateOption);
    },
    parseAuthor(author) {
      author = author.replace(/\./, " ");
      return author.toLowerCase();
    },
    addLegend(colors, svg, keys) {
      let reverseColors = colors.reverse(); // Pour présenter les catégories dans le même sens qu'elles sont utilisées
      let reverseKeys = keys.reverse();
      let legend = svg.append("g").attr("transform", "translate(100, 0)"); // Représente le point précis en haut à gauche du premier carré de couleur

      // Pour chaque couleur, on ajoute un carré toujours positionné au même endroit sur l'axe X et décalé en fonction de la
      // taille du carré et de l'indice de la couleur traitée sur l'axe Y
      legend
        .selectAll()
        .data(reverseColors)
        .enter()
        .append("rect")
        .attr("height", this.legendCellSize + "px")
        .attr("width", this.legendCellSize + "px")
        .attr("x", this.width - 5)
        .attr("y", (d, i) => i * this.legendCellSize)
        .style("fill", d => d);

      // On procéde de la même façon sur les libellés avec un positionement sur l'axe X de la taille des carrés
      // à laquelle on rajoute 10 px de marge
      legend
        .selectAll()
        .data(reverseKeys)
        .enter()
        .append("text")
        .attr(
          "transform",
          (d, i) =>
            "translate(" +
            (this.width - 130) +
            ", " +
            i * this.legendCellSize +
            ")"
        )
        .attr("dy", this.legendCellSize / 1.6) // Pour centrer le texte par rapport aux carrés
        .style("font-size", "15px")
        .style("fill", "white")
        .style("font-family", "Helvetica")
        .text(d => d);
    }
  }
};
</script>
